package aud.exam.prep;

import java.util.Comparator;

public interface SequenceProcessor<T, S> {

    boolean find(S s, T t);

    boolean findBinary(S s, T t, Comparator<T> cmp);

    boolean override(S s, T from, T to);

    boolean overrideAll(S s, T from, T to);

    boolean overrideAt(S s, T to, int index);

    void insertInOrder(S s, T t, Comparator<T> cmp);

    boolean remove(S s, T t);

    boolean removeAll(S s, T t);

    boolean isAscending(S s, Comparator<T> cmp);

    T max(S s, Comparator<T> cmp);

    T secondMax(S s, Comparator<T> cmp);

    boolean check(S s);

    boolean isItemWiseLessOrEqual(S a, S b, Comparator<T> cmp);

    boolean isItemWiseLess(S a, S b, Comparator<T> cmp);

    boolean isLexSmaller(S a, S b, Comparator<T> cmp);

    void exchangePairs(S s);

    void rotateTriples(S s);

    void removeEverySecond(S s);

    void doubleAllKeys(S s);

    S rotateRight(S s);

    S rotateLeft(S s);

    void removeDuplicates(S s);

    S invert(S s);

    S clone(S s);

    S alternate(S a, S b);

    S merge(S a, S b, Comparator<T> cmp);

    Pair<S, S> divideAlternating(S s);

    Pair<S, S> divideAlternatingByRuns(S s, Comparator<T> cmp);

    Pair<S, S> divideByPivot(S s, T pivot, Comparator<T> cmp);

    S create(Iterable<T> iterable);

    Iterable<T> iterate(S s);
}
